var Tail, events, fs;
var __hasProp = Object.prototype.hasOwnProperty, __extends = function(child, parent) {
  for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; }
  function ctor() { this.constructor = child; }
  ctor.prototype = parent.prototype;
  child.prototype = new ctor;
  child.__super__ = parent.prototype;
  return child;
}, __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };
events = require("events");
fs = require('fs');
Tail = (function() {
  __extends(Tail, events.EventEmitter);
  function Tail(filename, separator) {
    var buffer;
    this.filename = filename;
    this.separator = separator || '\n';
    buffer = '';
    fs.watchFile(this.filename, __bind(function(curr, prev) {
      var stream;
      if (curr.size > prev.size) {
        stream = fs.createReadStream(this.filename, {
          start: prev.size,
          end: curr.size,
          encoding: "utf-8"
        });
        stream.on('error', __bind(function(error) {
          return this.emit('error', error);
        }, this));
        stream.on('end', __bind(function() {
          return this.emit('end');
        }, this));
        stream.on('close', __bind(function() {
          return this.emit('close');
        }, this));
        stream.on('fd', __bind(function(fd) {
          return this.emit('fd', fd);
        }, this));
        return stream.on('data', __bind(function(data) {
          var chunk, parts, _i, _len, _results;
          buffer += data;
          parts = buffer.split(this.separator);
          buffer = parts.pop();
          _results = [];
          for (_i = 0, _len = parts.length; _i < _len; _i++) {
            chunk = parts[_i];
            _results.push(this.emit("data", chunk));
          }
          return _results;
        }, this));
      }
    }, this));
  }
  return Tail;
})();
exports.Tail = Tail;